/*
    Copyright 2020, Prusa Research a.s.

    This file is part of touch-ui

    touch-ui is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

import QtQuick 2.12
import Qt.labs.settings 1.0
import PrusaComponents 1.0

Item {
    id: root

    Settings {
        id: settings
        fileName: configPath
        category: "display"
        property int screenSaverDelayMs: 0
    }

    property bool enabled: true
    property alias  delayMs: settings.screenSaverDelayMs

    function activity() {
        if(! backlight.enabled) {
            console.log("ScreenSaver: Enabling backlight.")
            backlight.enabled = true
        }
        if(enabled && delayMs > 0) {
            timer.restart()
        }
    }

    MouseArea {
        anchors.fill: parent
        onPressed: (mouse)=>{
            if(backlight.enabled) {
                mouse.accepted = false
            }
            root.activity()
        }
    }

    Timer {
        id: timer
        running: enabled && delayMs > 0
        interval: delayMs
        onTriggered: ()=>{
            console.log("ScreenSaver: Disabling backlight.")
            backlight.enabled = false
        }
    }
}
